%% Ejemplo 4: Codigo Huffman de una imagen

clear all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Proceso de codificacin
I = imread('lenna.tif'); % Se lee la imagen
[M N]=size(I); % Se calcula el tamao de la matriz
imhist(I,256), axis tight; % Se dibuja el histograma

% Se calcula valores de pixels (symbols) y probabilidad (p)
[p,symbols]=imhist(I);
prob=p/(M*N);

% Se construye la Tabla de Huffman: Cdigo de Huffman
[dict,avglen]=huffmandict(symbols,prob);

% Se convierte una matriz 2D -> 1D (array)
for x=1:M
    A_1D((x-1)*N+1:x*N)=I(x,:);
end

% Codificacion huffman de la matriz 1D
cod=huffmanenco(A_1D,dict);

% Compression ratio
fprintf('\nCompression ratio: %4.5f\n', (M*N*8)/length(cod));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Proceso de decodificacin
% Decodificacion huffman de la matriz 1D
decod=huffmandeco(cod,dict);

% Se convierte una matriz 1D -> 2D size MxN
for x=1:M
    D(x,:)=uint8(decod((x-1)*N+1:x*N));
end

% Visualizacin de imgenes
subplot(1,2,1), imshow(I), title('IMAGEN ORIGINAL');
subplot(1,2,2), imshow(D), title('IMAGEN DECODIFICADA');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo y Juan A. Michell                    %%
%% ruizrg@unican.es, michellj@unican.es                         %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
